using System;
using System.Collections.Generic;
using System.Text;

namespace Rocket.Core.Common
{
    /// <summary>
    /// Status code to be used with Rocket.CoreResponse object
    /// </summary>
    public enum StatusCodes
    {
        Failed,
        Successful,
        None
    }

    /// <summary>
    /// Pattern to be used when comparing for string patterns
    /// </summary>
    public enum RegXPatterns
    {
        IsIPAddress,
        IsEmailAddress,
        IsURL,
        IsNumbers,
        IsAlphaNumberic,
        IsUSAZip,
        IsUSAPhoneNumber,
        IsUSASSNumber,
        IsUSACreditCardNumber,
        IsAlphabet_azAZ,
        IsAlphabet_AZaz,
        IsDateTime_MMDDYYYMH,
        IsDateTime_DDMMYYYMH,
        IsDateTime_MMDDYYYY,
        IsDateTime_DDMMYYYY,
        IsDateTime_MMDDYY,
        IsDateTime_DDMMYY
    }
}
