﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Rocket.Core.Common
{
    public class ShowInGridAttribute : System.Attribute 
    { 
        public bool ColumnVisible { get; set; } 
        public string ColumnText { get; set; } 
        public ShowInGridAttribute(bool visible) 
        { this.ColumnVisible = visible; this.ColumnText = String.Empty; } 
        public ShowInGridAttribute(bool visible, string columnText) : this(visible) 
        { this.ColumnText = columnText; } 
    }

    public class EnableCellEditAttribute : System.Attribute
    {
        public bool CellEditable { get; set; }
        public EnableCellEditAttribute(bool cellEditable)
        {
            this.CellEditable = cellEditable;
        }
    }
}
