﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Rocket.Core
{
    public interface IContainerViewer<B, H, V>
        where H: IHandler<V>
        where V : BaseObject
    {
        H IHandler
        {
            get;
        }

        IRocketViewer<B> IRocketViewer
        {
            get;
        }

        V BindedView
        {
            get;
        }

        void SetRocketBindingSourceView(V dataSource);

        /// <summary>
        /// Reinitialize the binding source and reset all control values
        /// </summary>
        bool RocketRefresh();
        /// <summary>
        /// Load the data using the handler
        /// </summary>
        bool RocketLoad();
    }
}
